<?php

$block_name = _("Ticket Summary");

/**
 * Horde_Block_Whups_summary:: Implementation of the Horde_Block API
 * to display a summary of the current user's tickets.
 *
 * $Horde: whups/lib/Block/summary.php,v 1.23 2005/09/06 00:31:51 chuck Exp $
 *
 * @package Horde_Block
 */
class Horde_Block_Whups_summary extends Horde_Block {

    var $_app = 'whups';

    /**
     * The title to go in this block.
     *
     * @return string   The title text.
     */
    function _title()
    {
        global $registry;

        return '<form method="get" action="' . Horde::applicationUrl('ticket/', false, -1) . '">' . Util::formInput() .
            Horde::link(Horde::url($registry->getInitialPage(), true), $registry->get('name'), 'header') . $registry->get('name') . '</a> :: ' .
            Horde::link(Horde::applicationUrl('ticket/create.php', true), _("New Ticket"), 'smallheader') . Horde::img('whups.png', _("New Ticket"), '', Horde::url($registry->getImageDir(), true, -1)) . _("New Ticket") . '</a>' .
            ' :: <input style="font-size:10px;" type="text" size="4" name="id" /><input type="submit" onclick="if (!document.tjump.id.value) return false;" class="button" value="' . _("Go") . '" />' .
            '</form>';
    }

    /**
     * The content to go in this block.
     *
     * @return string   The content
     */
    function _content()
    {
        require_once dirname(__FILE__) . '/../base.php';
        global $whups, $registry, $prefs;

        $html = '';
        $info = array('owner' => Whups::getOwnerCriteria(Auth::getAuth()),
                      'nores' => true);
        $assigned = $whups->getTicketsByProperties($info);
        if (is_a($assigned, 'PEAR_Error')) {
            return $assigned;
        }
        if (count($assigned)) {
            Whups::sortTickets($assigned);
            $html .= '<tr><td colspan="3" class="text"><strong>' . _("Tickets assigned to you") . '</strong></td></tr>';
            $this->_list($assigned, $html);
        }

        if ($prefs->getValue('summary_show_requested')) {
            $info = array('requester' => Auth::getAuth(),
                          'notowner' => 'user:' . Auth::getAuth(),
                          'nores' => true);
            $tickets = $whups->getTicketsByProperties($info);
            if (is_a($tickets, 'PEAR_Error')) {
                return $tickets;
            }
            if (count($tickets)) {
                Whups::sortTickets($tickets);
                if (count($assigned)) {
                    $html .= '<tr><td>&nbsp;</td></tr>';
                }
                $html .= '<tr><td colspan="3" class="text"><strong>' . _("Tickets you requested") . '</strong></td></tr>';
                $this->_list($tickets, $html);
            }
        }

        if (empty($html)) {
            $html = sprintf('<tr><td><em>%s</em></td></tr>', _("No tickets to display"));
        }

        $html = '<table cellspacing="0" width="100%">' . $html . '</table>';

        return $html;
    }

    function _list(&$tickets, &$html)
    {
        global $prefs;

        foreach ($tickets as $ticket) {
            if (empty($ticket['summary'])) {
                $ticket['summary'] = _("<em>No summary</em>");
            }
            if ($prefs->getValue('summary_show_ticket_numbers')) {
                $ticket['summary'] = '[' . $ticket['id'] . '] ' . $ticket['summary'];
            }
            $html .= '<tr><td valign="top" class="text">' . Horde::link(Horde::applicationUrl('ticket/?id=' . $ticket['id'], true), $ticket['summary']) . htmlspecialchars($ticket['summary']) . '</a></td>' .
                '<td valign="top" class="text nowrap">' . htmlspecialchars($ticket['priority_name']) . '</td>' .
                '<td valign="top" class="text">' . htmlspecialchars($ticket['state_name']) . '</td></tr>';
        }
    }

}
